//this file is part of aMule
//aMule Copyright (C)2003 aMule Team ( http://www.amule-project.net )
//This file Copyright (C)2003 Kry (elkry@sourceforge.net  http://www.amule-project.net )
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.#include <stdio.h>

#include <stdlib.h>
#include <string.h>
#include "TextClient.h"

#define CMD_ID_QUIT -1
#define CMD_ID_HELP 1
#define CMD_ID_STATS 2
#define CMD_ID_SHOW 3
#define CMD_ID_RESUME 4
#define CMD_ID_PAUSE 5
#define CMD_ID_SRVSTAT 6
#define CMD_ID_CONN 7
#define CMD_ID_DISCONN 8

IMPLEMENT_APP(CamulecmdApp)

MuleConnection *	conn = NULL;
MuleClient *				client;

wxConnectionBase *MuleClient::OnMakeConnection()
{
    return new MuleConnection;
}

bool MuleConnection::OnAdvise(const wxString& topic, const wxString& item, wxChar *data, int size, wxIPCFormat format)
{
    return TRUE;
}

bool MuleConnection::OnDisconnect()
{
	printf("Disconnected: aMule might have exited\n");
	theApp.OnExit();
 	conn = NULL;
    return wxConnection::OnDisconnect();
}

void ShowGreet() {
	printf("\n---------------------------------\n");
	printf("|       aMule text client       |\n");
	printf("---------------------------------\n\n");
	printf("\nUse 'Help' for command list\n\n");
}

void ShowHelp() {
	printf("\n->Help: Avalaible commands :\n\n");	
	printf("Quit: Exits Textclient.\t\t\t\t\tSyns: quit, Exit, exit\n");	
	printf("Help: Shows this help.\t\t\t\t\tSyns: help\n");	
	printf("Stats: Shows statistics.\t\t\t\tSyns: stats\n");	
	printf("Show DL: Shows Download queue\n");	
	printf("Resume n: Resume file number n.\t\t\t\tSyns: resume\n");
	printf("Pause n: Pauses file number n.\t\t\t\tSyns: pause\n");
	printf("ServerStatus: Tell us if connected/not connected. \tSyns: serverstatus\n");
	printf("Connect: Tries to connect to any server.\t\tSyns: connect\n");
	printf("\tWARNING: Doesn't warn if failed.\n");
	printf("Disconnect: Disconnect from server. \t\t\tSyns: disconnect\n\n");
	printf("->End of listing\n");
}

int GetCommand(char * buffer) {
	printf("\naMule$ "); 
	fflush(stdin);
	return scanf("%s",buffer);
}


int GetIDFromString(char* buffer) {
	if ((strncmp(buffer,"Quit",4)==0) || (strncmp(buffer,"quit",4)==0) || (strncmp(buffer,"Exit",4)==0) || (strncmp(buffer,"exit",4) ==0)) {
		return(CMD_ID_QUIT);
	} else if ((strncmp(buffer,"Help",4)==0) || (strncmp(buffer,"help",4)==0)) {
		return(CMD_ID_HELP);
	} else if ((strncmp(buffer,"Stats",5)==0) || (strncmp(buffer,"stats",5)==0)) {
		return(CMD_ID_STATS);
	} else if ((strncmp(buffer,"Show",5)==0) || (strncmp(buffer,"show",5)==0)) {
		return(CMD_ID_SHOW);
	} else if ((strncmp(buffer,"pause",5)==0) || (strncmp(buffer,"Pause",5)==0)) {
		return(CMD_ID_PAUSE);
	} else if ((strncmp(buffer,"resume",6)==0) || (strncmp(buffer,"Resume",6)==0)) {
		return(CMD_ID_RESUME);
	} else if ((strncmp(buffer,"serverstatus",12)==0) || (strncmp(buffer,"ServerStatus",12)==0)) {
		return(CMD_ID_SRVSTAT);
	} else if ((strncmp(buffer,"connect",7)==0) || (strncmp(buffer,"Connect",7)==0)) {
		return(CMD_ID_CONN);
	} else if ((strncmp(buffer,"disconnect",10)==0) || (strncmp(buffer,"Disconnect",10)==0)) {
		return(CMD_ID_DISCONN);
	}
	return(0);
}

int ProcessCommand(int ID) {
	int fileID;
	char reqbuffer [256];	
	switch (ID) {
				case CMD_ID_HELP:
					ShowHelp();
				    break;
 				case CMD_ID_STATS:
					printf("%s\n", conn->Request("STATS", NULL));
				break;
 				case CMD_ID_SRVSTAT:
					printf("%s\n", conn->Request("CONNSTAT", NULL));
				break;
 				case CMD_ID_CONN:
					printf("%s\n", conn->Request("RECONN", NULL));
				break;
 				case CMD_ID_DISCONN:
					printf("%s\n", conn->Request("DISCONN", NULL));
				break;
 				case CMD_ID_PAUSE:
					if (scanf("%i",&fileID)) {
						sprintf(reqbuffer,"PAUSE%i",fileID);
				    	printf("%s\n", conn->Request(reqbuffer, NULL));
					} else printf("Not a valid number\n");
				break;
 				case CMD_ID_RESUME:
					if (scanf("%i",&fileID)) {
						sprintf(reqbuffer,"RESUME%i",fileID);
				    	printf("%s\n", conn->Request(reqbuffer, NULL));
					} else printf("Not a valid number\n");
				break;
 				case CMD_ID_SHOW:
					char buffer[256];
					scanf("%s",buffer);
					if (strncmp(buffer,"DL",2)==0) {
							printf("%s\n", conn->Request("DL_QUEUE", NULL));
					} else if (strncmp(buffer,"DL",2)==0) {
							printf("%s\n", conn->Request("UL_QUEUE", NULL));
					} else printf("Hint: Use Show DL or Show UL\n");
				break;
				default:
					return(-1);
					break;
			}
	return(0);
}

void TextClientShell() {
	char buffer[256];
	bool The_End=false;
	int cmd_ID;
	do
		if (GetCommand(buffer)) {
			cmd_ID=GetIDFromString(buffer);
			if (cmd_ID) {
				if (cmd_ID==CMD_ID_QUIT) {
					The_End=true;
				} else {
						if (ProcessCommand(cmd_ID)<0) {
							printf("Error processing command - should never happen! Report bug, please\n");
						} 
				}
			} else printf("Syntax error!\n");
		} else printf("Wrong input!!!\n");		
	 while (!The_End);
}


bool CamulecmdApp::OnInit() {
	
	wxString server = getenv("HOME") + wxString("/.aMule/muleconn");
	wxString hostName = "localhost";
	printf("\nCreating client...\n");
	client = new MuleClient;
	printf("Now, doing connection....\n");
	conn = (MuleConnection *) client->MakeConnection(hostName, server,  "aMulecmd IPC");
	if (!conn) {
		// no connection => close gracefully
		printf("aMule is not running\n");
		} else {
		ShowGreet();
		TextClientShell();
		printf("\nOk, exiting Text Client...\n");
		conn->Disconnect();
	}
	theApp.OnExit();  // This is not clean... but why doesn't it call OnExit(); ??
	return TRUE;
}

int CamulecmdApp::OnExit()
{
	if (conn) {
		delete conn;
	}
	if (client) {
    	delete client;
	}
	//return wxApp::OnExit();
    exit (0); // This is not clean... but why doesn't it exit by OnExit();?????????
}
